#pragma once

#include <gl\glew.h>
#include <GLFW\glfw3.h>
#include <iostream>

// http://ogldev.atspace.co.uk/www/tutorial43/tutorial43.html
class FrameBufferObject
{
public:
	FrameBufferObject(void);
	~FrameBufferObject(void);

	bool init(int width, int height);

	void BindForWriting();
	void UnBindForWriting();

	void BindForReadingTextureMap(GLenum TextureUnit);
	void BindForReadingDepthMap(GLenum TextureUnit);

	void ClearColorWhite();
	void ClearColorTransparent();

	void PrepareForFlameMap(int i);
	void PrepareForShadowMap();

	int getFramebufferHeight(void);
	int getFramebufferWidth(void);

private:
	GLuint m_fbo, m_shadowMap, m_depth, m_renderedTexture;
	int windowHeight, windowWidth;
};

