#pragma once

#include <GL/glew.h>
#include <GLFW\glfw3.h>
#include <iostream>

#include "Window.h"
#include "Scene.h"

class KeyboardManager
{
public:
	static void keyboardInput(GLFWwindow * _window, int key, int scancode, int action, int mods);
	static void init(Window * _window);
	static int getKey();

	static glm::vec3 getVectorPlayer();
	static glm::vec3 getVectorDebugCam();
	static glm::vec3 getVectorDebugLight();
	static bool isViewFrustumEnabled(void);
	static bool isFillPolygonsEnabled(void);
	static bool isFrameTimeEnabled(void);
	static bool isInvisabilityEnabled(void);
	static bool isInformationRequired(void);
	static bool isTextureSamplingLinear(void);
	static int levelOfMipMapping(void);

private:
	static bool w, a, s, d;

	static bool isInit;
	static Window *window;
	static int lastPressedKey;

	static glm::vec3 vectorPlayer;
	static glm::vec3 vectorDebugCam;
	static glm::vec3 vectorDebugLight;

	static bool viewFrustum;
	static bool fillPolygon;
	static bool drawFrameTime;
	static bool transparency;
	static bool changedInformations;
	static bool textureSampling;
	static int mipMapping;
};

