#include "SoundManager.h"


void SoundManager::init(void)
{
	hasMusic = Settings::getMusic();
	hasSoundFX = Settings::getSoundFX();

	engine = irrklang::createIrrKlangDevice();
	engine->setSoundVolume(0.6f);
}
void SoundManager::setSoundVolume(float value) 
{
	engine->setSoundVolume(value);
}
void SoundManager::playSound(SOUND_COLLECTION title, SOUND_SOURCE source, bool loop)
{
	std::string musicToPlay ="ExFlame/Audio/";
	if(engine && hasMusic) {
		bool shouldPlay = true;
		switch(title) {
			case SOUND_COLLECTION::AMBIENT_FAST:
				musicToPlay += "Ambient/fast.mp3";
				break;
			case SOUND_COLLECTION::AMBIENT_MEDIUM:
				{
					std::cout << " play Ambient" << std::endl;
				musicToPlay += "Ambient/ambient1.mp3";
				break;
				}
			case SOUND_COLLECTION::AMBIENT_HARDCORE:
				musicToPlay += "Ambient/hardcore.mp3";
				break;
			case SOUND_COLLECTION::AMBIENT_FORGET_IT:
				musicToPlay += "Ambient/forget_it.mp3";
				break;
			default: shouldPlay = false;
		}
		if(shouldPlay && !engine->isCurrentlyPlaying(musicToPlay.c_str())) {
			engine->play2D(musicToPlay.c_str(),loop);
		}
	}
	
	if(engine && hasSoundFX) {
		bool shouldPlay = true;
		switch(title) {
		case SOUND_COLLECTION::HERO_DYING_FALLING:
				musicToPlay += "Hero/dying_falling.mp3";
				break;
		case SOUND_COLLECTION::HERO_DYING_FLAME:
				musicToPlay += "Hero/dying_flame.mp3";
				break;
		case SOUND_COLLECTION::HERO_GOING:
				musicToPlay += "Hero/going.mp3";
				break;
		case SOUND_COLLECTION::HERO_JUMP:
			{
				int r = rand() % 2;
				musicToPlay += r == 0 ?  "Hero/jump.mp3": "Hero/jump1.mp3";
				break;
			}
		case SOUND_COLLECTION::ENEMY_BURNING1:
				musicToPlay += "Enemy/burning.mp3";
				break;
		case SOUND_COLLECTION::ENEMY_BURNING2:
				musicToPlay += "Enemy/burning2.mp3";
				break;
		case SOUND_COLLECTION::ENEMY_BURNING3:
				musicToPlay += "Enemy/burning3.mp3";
				break;
		case SOUND_COLLECTION::CUBE_BREAK:
				musicToPlay += "Cube/break.mp3";
				break;
		case SOUND_COLLECTION::CUBE_MOVING:
				musicToPlay += "Cube/moving.mp3";
				break;
		case SOUND_COLLECTION::CUBE_ROTATING:
				musicToPlay += "Cube/rotating.mp3";
				break;
			default: shouldPlay = false; break;
		}

		if(!engine->isCurrentlyPlaying(musicToPlay.c_str()))
		{
			engine->play2D(musicToPlay.c_str(),loop);
		}

		//if(shouldPlay && !engine->isCurrentlyPlaying(musicToPlay.c_str())) engine->play2D(musicToPlay.c_str(),loop);
	}
}

bool SoundManager::hasSoundFX = false;
bool SoundManager::hasMusic = false;
irrklang::ISoundEngine* SoundManager::engine;