#pragma once

#include <gl/glew.h>
#include <glfw/glfw3.h>
#include <string>

#include "irrKlang/irrKlang.h"
#include "../Settings.h"

class SoundManager
{
public:
	enum SOUND_COLLECTION {
		AMBIENT_MEDIUM,
		AMBIENT_FAST,
		AMBIENT_HARDCORE,
		AMBIENT_FORGET_IT,
		HERO_GOING,
		HERO_JUMP,
		HERO_DYING_FLAME,
		HERO_DYING_FALLING,
		ENEMY_BURNING1,
		ENEMY_BURNING2,
		ENEMY_BURNING3,
		CUBE_ROTATING,
		CUBE_MOVING,
		CUBE_BREAK
	};

	enum SOUND_SOURCE {
		HERO,
		FLAME,
		WORLD
	};

	static void init();
	//static void playSound(void);
	static void playSound(SOUND_COLLECTION titel, SOUND_SOURCE source, bool loop);
	static void setSoundVolume(float value);

private:
	static irrklang::ISoundEngine *engine;
	static bool hasSoundFX, hasMusic;
};

