#pragma once

#include <GLFW\glfw3.h>

class Window
{
	public:
		Window(int width, int height, int framerate, bool fullscreen);
		~Window();

		void init();

		void makeContext();
		bool shouldClose();
		void swapBuffers();

		GLint getFramebufferWidth();
		GLint getFramebufferHeight();

		bool getKey(GLint);

		void cleanUp();
		
		GLFWwindow * getWindow();
		GLdouble getDeltaT();

		void setKeyboard(GLFWkeyfun function);
		void resizeWindow(void);

	private:
		GLdouble lastTime;
		GLdouble deltaT;
		GLFWwindow * window;

		int width, height;
};

