#include "Cube.h"


Cube::Cube(glm::vec3 _position)
	: SceneObject("cube/cube", _position, 2.0f, 1.0f)
{
	material = new Material(0.2f, 1.5f, 0.2f);
	dead = false;
}

Cube::~Cube(void)
{
}

void Cube::draw(RENDERTYPE mode)
{
	if(mode == RENDERTYPE::DEPTHSHADER) {
		//DepthShader
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::DEPTHSHADER,  "modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		SceneObject::draw(mode);
	} else if(mode == RENDERTYPE::BASIC) {
		//BasicShader
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::BASICSHADER, "modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		SceneObject::draw(mode);
	} else if(mode == RENDERTYPE::FLAMESHADER) {
	} else if(mode == RENDERTYPE::TRANSPARENCY) {
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::BASICSHADER,  "modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		SceneObject::draw(mode);
	}
	
}

bool Cube::isDead() {
	return dead;
}

void Cube::update(float deltaT)
{
	modelMatrix = glm::translate(position);
}

void Cube::setPositionHero(glm::vec3 posHero)
{
	positionHero = posHero;
}
