#pragma once

#include <glm/glm.hpp>

#include "../sceneobject.h"
#include "../Shader.h"
#include "../../GameEngine/SoundManager.h"

#define WALKING_SPEED 1.f;

class Flame :
	public SceneObject
{
public:
	Flame(glm::vec3 _position);
	~Flame(void);

	void virtual draw(RENDERTYPE mode);
	void virtual update(GLdouble deltaT);
	void setPositionHero(glm::vec3 _position);
	void changeDebugMode();
	void setDebugVector(glm::vec3 vector);
	void playSound(SoundManager::SOUND_COLLECTION entry, bool loop) override;
	void setDistances(float _maxDistance, float _minDistance);
	glm::vec3 getPositionDebug(void);

private:
	glm::vec3 positionHero;
	glm::vec3 positionDebug;
	glm::vec3 vectorDebug;
	glm::vec3 color;
	float maxDistance, minDistance;
	bool isDebugMode;
};

