#include "Goodie.h"


Goodie::Goodie(glm::vec3 position)
	:SceneObject("Goodie/Goodie", position, 1.0f, 1.0f)
{
}


Goodie::~Goodie(void)
{
}

void Goodie::update(double deltaT) 
{
	switch (state) {
	case GOODIE_STATE::LYING: 
		modelMatrix = modelMatrixParent * glm::translate(position); 
		break;
	case GOODIE_STATE::COLLECTED: 
		modelMatrix = modelMatrixParent * glm::rotate(45.0f, glm::vec3(0.0f, 1.0f, 0.0f)) * glm::translate(glm::vec3(0.0f, sin(deltaT) * 0.5f, 1.0f));
		break;
	case GOODIE_STATE::GONE: break;
	default: break;
	}
}

void Goodie::updateModelMatrixAtChildren(glm::mat4 modelMat)
{
	modelMatrixParent = modelMat;
}

int Goodie::goodieCollected(glm::vec3 pos) 
{
	glm::vec3 distance = pos - position;

	float length = glm::length(distance);

	if (length < collectableDistance)  {
		state = GOODIE_STATE::COLLECTED;
		return 1;
	} else return 0;
}

void Goodie::draw(RENDERTYPE mode)
{
	if(mode == RENDERTYPE::DEPTHSHADER) {
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::DEPTHSHADER, "modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		SceneObject::draw(mode);
	} else if(mode == RENDERTYPE::BASIC) {
		glUniformMatrix4fv(shaderManager->getUniformLoc(ShaderManager::SHADER::BASICSHADER, "modelMatrix"), 1, 
			GL_FALSE, glm::value_ptr(modelMatrix));
		SceneObject::draw(mode);
	}
}
