#pragma once

#include <string>
#include <gl/glew.h>
#include <glfw/glfw3.h>
#include <glm/glm.hpp>
#include <iostream>

class Texture
{
public:
	Texture(const std::string& path);
	~Texture(void);

	void bind(int unit);
	void setTextureSampling(int mode);
	void setMipMapping(int mode);

private:
	void loadTexture(std::string path);
	void loadTextureWithFreeImage(std::string path);
	void setTexture(void);
	void setTextureConfiguration(int modeTextureSampling, int modeMipMapping);
	
	int textureSamplingMode;
	int mipMappingMode;

	unsigned int width, height;
	unsigned char * data; 

	GLuint handle;
};

