#version 330 core

layout(location = 0) out vec4 fragcolor; 

in vec2 texCoord;

uniform sampler2D glowTexture;
uniform float windowWidth;
uniform float windowHeight;
uniform int pass;
uniform int border;

float gaus[9] = float[](0.0039, 0.0313, 0.1094, 0.2187, 0.2734, 0.2187, 0.1094,  0.0313 ,0.0039);
float gaus2[7] = float[](0.015625, 0.09375, 0.234375, 0.3125, 0.234375, 0.09375, 0.015625);

void main()
{
	fragcolor = vec4(0.0);
	if(pass == 1) {

		for(int i = 0; i < 9; i++)
		{ 
			//texture(asdf, texCoord)+vec2(0.0, offset * viewportwidth* weight)
			//float x = texCoord.x + ((-3 + i) / windowWidth * 1.0);
			//fragcolor += gaus2[i] * texture(glowTexture, vec2(x, texCoord.y));
			
			fragcolor += texture(glowTexture, vec2(texCoord) + vec2((4-i)/windowWidth,0.0))*gaus[i];			
		}
	} else if(pass == 2)
	{
		for(int i = 0; i < 9; i++)
		{ 
			//float y = texCoord.y + ((-3 + i) / windowHeight * 1.0);
			//fragcolor += gaus2[i] *texture(glowTexture, vec2(texCoord.x, y)) ;			
			fragcolor += texture(glowTexture, vec2(texCoord) + vec2(0.0,(4-i)/windowHeight))*gaus[i];			
		}
	} else if(pass==3) {
		fragcolor = texture(glowTexture, texCoord);

		if(gl_FragCoord.y > border || gl_FragCoord.y < border/9) 
		{ 
			fragcolor = vec4(vec3(0.0),1.0);
		}
	}
}